
#include "ET++.h"
#include "ShapeDialog.h"

//---- ShapeDialog -------------------------------------------------------------

const int cIdPattern = cIdFirstUser + 1;

MetaImpl(ShapeDialog, (TP(pattern), TP(title), T(ink), TP(shape)));


VObject *ShapeDialog::DoCreateDialog()
{
    pattern = new OneOfCluster(cIdPattern, (VObjAlign)(eVObjHLeft|eVObjVTop),
    			Point(15, 5),
    			"White" , "Grey25", "Grey50", "Grey75", "Black", 
    			"Patt00", "Patt01", "Patt02",
    			"Red", "Green", "Blue", "",
    			0
    	        );


    VObject *Actions = 
    	new Cluster(cIdNone, eVObjVCenter, 8,
    		new ActionButton(cIdOk, "OK", TRUE),
    		new ActionButton(cIdCancel, "Cancel"),
    		new ActionButton(cIdDefault, "Default"),
    		0
    	);

    return new BorderItem(new Cluster(cIdNone, eVObjHCenter, 20,
    				new BorderItem("Shapes", pattern),
    				Actions,
    				0
    			)
    		);
}

void ShapeDialog::DoSetup()
{
    EnableItem(cIdYes,     TRUE);
    EnableItem(cIdCancel,  TRUE);
    EnableItem(cIdDefault, TRUE);
    EnableItem(cIdPattern, TRUE);

    pattern->SetItemOn(shape->GetPattern() + cIdPattern);
}

void ShapeDialog::DoSetDefaults()
{
    pattern->SetItemOn(cIdPattern+8);
}

void ShapeDialog::DoSave()
{
    ink = pattern->GetCurrentItem();
}

void ShapeDialog::DoRestore()
{
    pattern->SetItemOn(ink);
}

void ShapeDialog::DoStore()
{
    int id = pattern->GetCurrentItem() - cIdPattern;
    
    if (palette[id])
    	shape->SetPattern(id);
    else
    	DoRestore();
}



