//
// File: ShapeView.h
//

#ifndef ShapeView_First
#define ShapeView_First

#include "View.h"
#include "Shapes.h"
#include "ShapeDialog.h"

//---- ShapeView -------------------------------------------------------------+

class ShapeView: public View {
    Shape *shape1, *shape2;
    Shape *selected;
    ShapeDialog *dialog;
public:
    MetaDef(ShapeView);

    ShapeView(Document *d, Point ext);
    ~ShapeView();

    void Draw(Rectangle r);
    Command *DoLeftButtonDownCommand(Point, Token, int);
    Command *DoMiddleButtonDownCommand(Point, Token, int);
    Command *DoMenuCommand(int);
    void DoCreateMenu(Menu*);
    void DoSetupMenu(Menu*);
    ostream &PrintOn(ostream &s)
        { return s << shape1 << shape2; }
    istream &ReadFrom(istream &);
};


#endif ShapeView_First
