#ifndef Shapes_First
#define Shapes_First

#include "VObject.h"
#include "TextView.h"
#include "Text.h"

//--- Shape --------------------------------------------------------------------

extern Ink *palette[];
 
class Shape: public VObject {
protected:
    int ink;
public:
    MetaDef(Shape);

    Shape(Rectangle r) : VObject(r)
        { ink= 8; }
    Metric GetMinSize()
        { return Metric(20); }
    void Draw(Rectangle)
        { GrSetInk(palette[ink]); }
    void SetPattern(int newpat);
    int GetPattern()
        { return ink; }
    Command *DoLeftButtonDownCommand(Point p, Token t, int cl);
    ostream &PrintOn(ostream &s);
    istream &ReadFrom(istream &s);
};

//---- BoxShape --------------------------------------------------------

class BoxShape: public Shape {
public:
    MetaDef(BoxShape);
    BoxShape(Rectangle r) : Shape(r)
        { }
    void Draw(Rectangle r)
        { Shape::Draw(r); GrFillRect(contentRect); GrStrokeRect(contentRect); }
};


//---- OvalShape --------------------------------------------------------

class OvalShape: public Shape {
public:
    MetaDef(OvalShape);
    OvalShape(Rectangle r) : Shape(r)
        { }
    void Draw(Rectangle r)
        { Shape::Draw(r); GrFillOval(contentRect); GrStrokeOval(contentRect); }
};

//---- TriangleShape --------------------------------------------------------

class TriangleShape: public Shape {
public:
    MetaDef(TriangleShape);
    TriangleShape(Rectangle r) : Shape(r)
        { }
    void Draw(Rectangle r);
};


//---- TextShape --------------------------------------------------------

class TextShape: public BoxShape {
    TextView *tv;
    Text *tx;
public:
    MetaDef(TextShape);
    TextShape(Rectangle);
    ~TextShape();

    void Init(Text*);
    void SetOrigin(Point at);
    void SetExtent(Point e);
    Metric GetMinSize()
        { return Metric(40, 10); }
    void Draw(Rectangle r);
    void Control(int, int part, void*);
    TextView *GetTextView()
        { return (TextView*) tv; }
    Command *DispatchEvents(Point p, Token &t, Clipper *vf);
    ostream &PrintOn(ostream &s);
    istream &ReadFrom(istream &s);
    void Parts(Collection*);
};

#endif Shapes_First
